import { Component, OnInit, ViewChild } from '@angular/core';
import { STColumn, STComponent } from '@delon/abc/st';
import { SFComponent, SFDateWidgetSchema, SFSchema, SFSchemaEnum, SFSelectWidgetSchema, SFUISchema } from '@delon/form';
import { ModalHelper, _HttpClient } from '@delon/theme';
import { NzModalService } from 'ng-zorro-antd/modal';
import { map } from 'rxjs/operators';
import { OrderManagementService } from '../../services/order-management.service';
import { UpdateFreightComponent } from '../../modal/bulk/update-freight/update-freight.component';
import { ConfirReceiptComponent } from '../../modal/bulk/confir-receipt/confir-receipt.component';
import { of } from 'rxjs';
import { ShipperBaseService } from '@shared';
import { Router } from '@angular/router';
import { orderManagementVoucherViewComponent } from '../../modal/audit/voucher-view/voucher-view.component';

@Component({
  selector: 'app-order-management-receipts-audit',
  templateUrl: './receipts-audit.component.html',
  styleUrls: ['./receipts-audit.component.less']
})
export class OrderManagementReceiptsAuditComponent implements OnInit {
  ui: SFUISchema = {};
  uiView: SFUISchema = {};
  schema: SFSchema = {};
  schemaView: SFSchema = {};
  auditMany = false;
  isVisibleView = false;
  isVisibleEvaluate = false;
  isVisible = false;
  _$expand = false;
  @ViewChild('st') private readonly st!: STComponent;
  @ViewChild('sf', { static: false }) sf!: SFComponent;
  columns: STColumn[] = [];
  resourceStatus: any;
  tabs = {
    receivedQuantity: 0,
    stayQuantity: 0,
    totalCount: 0
  };
  constructor(
    public service: OrderManagementService,
    private modal: NzModalService,
    public shipperservice: ShipperBaseService,
    private router: Router
  ) {}

  /**
   * 查询参数
   */
  get reqParams() {
    const a: any = {};
    if (this.resourceStatus) {
      a.billStatus = this.resourceStatus;
    }
    const params: any = Object.assign({}, this.sf?.value || {});
    delete params._$expand;
    return {
      ...a,
      ...params,
      createTime: {
        start: this.sf?.value?.createTime?.[0] || '',
        end: this.sf?.value?.createTime?.[1] || ''
      }
    };
  }
  get selectedRows() {
    return this.st?.list.filter(item => item.checked) || [];
  }
  search() {
    this.st?.load(1);
    this.getGoodsSourceStatistical();
  }
  getGoodsSourceStatistical() {
    this.tabs = {
      receivedQuantity: 0,
      stayQuantity: 0,
      totalCount: 0
    };
    const params: any = Object.assign({}, this.reqParams || {});
    delete params.billStatus
    this.service.request(this.service.$api_get_getAuditStatistical, params).subscribe(res => {
      if (res) {
        let totalCount = 0;
        res.forEach((element: any) => {
          if (element.billStatusLabel === '待审核') {
            this.tabs.receivedQuantity = element.quantity;
          } else if (element.billStatusLabel === '已审核') {
            this.tabs.stayQuantity = element.quantity;
          }
          totalCount += element.quantity;
        });
        this.tabs.totalCount = totalCount;
      }
    });
  }
  selectChange(e: number) {
    this.resourceStatus = e;
    this.initST();
    setTimeout(() => {
      this.st.load();
      this.getGoodsSourceStatistical();
    }, 500);
  }
  ngOnInit(): void {
    this.getGoodsSourceStatistical();
    this.initSF();
    this.initST();
  }

  /**
   * 初始化查询表单
   */
  initSF() {
    this.schema = {
      properties: {
        _$expand: { type: 'boolean', ui: { hidden: true } },
        billCode: {
          type: 'string',
          title: '订单号'
        },
        resourceCode: {
          type: 'string',
          title: '货源编号'
        },
        shipperAppUserId: {
          type: 'string',
          title: '货主',
          ui: {
            widget: 'select',
            serverSearch: true,
            searchDebounceTime: 300,
            searchLoadingText: '搜索中...',
            allowClear: true,
            onSearch: (q: any) => {
              if (!!q) {
                return this.service
                  .request(this.service.$api_enterpriceList, { enterpriseName: q })
                  .pipe(map((res: any) => (res as any[]).map(i => ({ label: i.enterpriseName, value: i.id } as SFSchemaEnum))))
                  .toPromise();
              } else {
                return of([]);
              }
            }
          } as SFSelectWidgetSchema
        },
        enterpriseProjectId: {
          type: 'string',
          title: '所属项目',
          ui: {
            widget: 'select',
            placeholder: '请选择',
            allowClear: true,
            asyncData: () => this.service.getEnterpriseProject(),
            visibleIf: {
              _$expand: (value: boolean) => value
            }
          },
          default: ''
        },
        loadingPlace: {
          type: 'string',
          title: '装货地',
          ui: {
            visibleIf: {
              _$expand: (value: boolean) => value
            }
          }
        },
        dischargePlace: {
          type: 'string',
          title: '卸货地',
          ui: {
            visibleIf: {
              _$expand: (value: boolean) => value
            }
          }
        },
        driverName: {
          title: '承运司机',
          type: 'string',
          ui: {
            visibleIf: {
              _$expand: (value: boolean) => value
            }
          }
        },
        carNo: {
          title: '车牌号',
          type: 'string',
          ui: {
            visibleIf: {
              _$expand: (value: boolean) => value
            }
          }
        },
        carCaptainName: {
          title: '车队长',
          type: 'string',
          ui: {
            visibleIf: {
              _$expand: (value: boolean) => value
            }
          }
        },
        paymentStatus: {
          title: '支付状态',
          type: 'string',
          ui: {
            widget: 'dict-select',
            params: { dictKey: 'overall:payment:status' },
            containsAllLable: true,
            visibleIf: {
              _$expand: (value: boolean) => value
            }
          } as SFSelectWidgetSchema
        },
        enterpriseInfoId: {
          type: 'string',
          title: '网络货运人',
          ui: {
            widget: 'select',
            placeholder: '请选择',
            allowClear: true,
            visibleIf: {
              _$expand: (value: boolean) => value
            },
            asyncData: () => this.shipperservice.getNetworkFreightForwarder()
          }
        },
        serviceType: {
          title: '服务类型',
          type: 'string',
          default: '',
          ui: {
            widget: 'dict-select',
            params: { dictKey: 'service:type' },
            containsAllLable: true,
            visibleIf: {
              _$expand: (value: boolean) => value
            }
          } as SFSelectWidgetSchema
        },
        settlementBasis: {
          title: '装卸凭证',
          type: 'string',
          ui: {
            widget: 'dict-select',
            containsAllLable: true,
            params: { dictKey: 'goodresource:settlement:type' },
            containAllLable: true,
            visibleIf: {
              _$expand: (value: boolean) => value
            }
          } as SFSelectWidgetSchema
        }
      },
      type: 'object'
    };
    this.ui = { '*': { spanLabelFixed: 110, grid: { span: 8, gutter: 4 } } };
  }

  /**
   * 初始化数据列表
   */
  initST() {
    this.columns = [
      { title: '', type: 'checkbox', fixed: 'left', width: '50px', className: 'text-center' },
      {
        title: '订单号',
        width: '180px',
        fixed: 'left',
        className: 'text-left',
        render: 'billCode'
      },
      {
        title: '运费明细',
        width: '250px',
        className: 'text-right',
        render: 'mybidDetailInfo'
      },
      { title: '网络货运人', index: 'enterpriseInfoName', width: '220px', className: 'text-left' },
      { title: '货主', index: 'shipperAppUserName', width: '220px', className: 'text-left' },
      { title: '所属项目', index: 'enterpriseProjectName', width: '220px', className: 'text-left' },
      { title: '货源编号', index: 'resourceCode', width: '180px', className: 'text-left' },
      { title: '装货地', index: 'loadingAddressArr', width: '180px', className: 'text-left' },
      {
        title: '卸货地',
        className: 'text-left',
        width: '180px',
        index: 'unloadingAddressArr'
      },
      {
        title: '货物信息',
        className: 'text-left',
        width: '250px',
        render: 'goodsName'
      },
      {
        title: '承运司机',
        className: 'text-left',
        width: '250px',
        index: 'driverName',
        render: 'driverName'
      },
      {
        title: '收款人',
        className: 'text-left',
        width: '180px',
        index: 'payeeName',
        render: 'payeeName'
      },
      {
        title: '装卸货时间',
        width: '200px',
        className: 'text-left',
        render: 'loadingTime'
      },
      {
        title: '装货凭证',
        width: '180px',
        className: 'text-left',
        render: 'loadingLadingBillFilePath'
      },
      {
        title: '卸货凭证',
        width: '180px',
        className: 'text-left',
        render: 'unloadingLadingBillFilePath'
      },
      {
        title: '操作',
        fixed: 'right',
        width: '120px',
        className: 'text-left',
        buttons: [
          {
            text: '通过',
            click: _record => this.sign(_record),
            iif: item => item.auditStatus == '1',
            acl: { ability: ['ORDER-RECEIPTS-billAuditPassBatch'] },
          },
          {
            text: '生成电子单据',
            click: _record => this.generate(_record, 2),
            iif: item => item.auditStatus == '1',
            acl: { ability: ['ORDER-RECEIPTS-generate'] },
          },
          {
            text: '查看凭证',
            click: _record => this.generate(_record, 3),
            iif: item => item.auditStatus == '2',
            acl: { ability: ['ORDER-RECEIPTS-view'] },
          },
          {
            text: '修改',
            click: _record => this.modification(_record),
            iif: item => item.auditStatus == '1' ,
            acl: { ability: ['ORDER-RECEIPTS-updateBillExamine'] },
          },
        ]
      }
    ];
  }
  /**
   * 查询字段个数
   */
  get queryFieldCount(): number {
    return Object.keys(this.schema?.properties || {}).length;
  }
  /**
   * 伸缩查询条件
   */
  expandToggle(): void {
    this._$expand = !this._$expand;
    this.sf?.setValue('/_$expand', this._$expand);
  }
  tabChange(item: any) {}
  /**
   * 重置表单
   */
  resetSF(): void {
    this.sf.reset();
    this._$expand = false;
  }

  /**
   * 导入货源
   */
  importGoodsSource() {}
  audit(item: any) {}

  /**
   * 审核通过按钮
   */
  handleOK() {}
  OpenPrice(item: any) {
    this.isVisible = true;
  }
  // 修改
  modification(item: any) {
    const modalRef = this.modal.create({
      nzTitle: '修改',
      nzWidth: '50%',
      nzContent: orderManagementVoucherViewComponent,
      nzComponentParams: {
        i: item,
        Status: 1
      },
      nzFooter: null
    });
    modalRef.afterClose.subscribe((result: any) => {
      this.st.load(1);
      this.getGoodsSourceStatistical()
  });
  }
  // 生成电子单据
  generate(item: any, sts?: number) {
    const modalRef = this.modal.create({
      nzTitle: '查看凭证',
      nzWidth: '50%',
      nzContent: orderManagementVoucherViewComponent,
      nzComponentParams: {
        i: item,
        Status: sts
      },
      nzFooter: null
    });
    modalRef.afterClose.subscribe((result: any) => {
      this.st.load(1);
      this.getGoodsSourceStatistical()
  });
  }
  // 通过
  sign(item?: any) {
    let params: any = []
    let text = '';
    if(item === '1') {
      if(this.selectedRows.length <= 0) {
        this.service.msgSrv.error('请选择订单！')
        return
      }
      this.selectedRows.forEach(ite => {
        params.push(ite.id);
      });
      text =  `<b>已选择${this.selectedRows.length}条订单，确认批量通过审核吗？</b>`
    } else {
      text =  `<b>确认通过审核吗？</b>`
      params.push(item.id);
    }
    console.log(this.selectedRows)
    console.log(params)
    this.modal.confirm({
      nzTitle: text,
      nzContent: `<b>通过后不可修改，可以再生成电子单据。</b>`,
      nzOnOk: () =>
        this.service.request(this.service.$api_get_billAuditPass, params).subscribe(res => {
          if (res === true) {
            this.service.msgSrv.success('操作成功！');
            this.st?.reload(1);
            this.getGoodsSourceStatistical();
            this.initST();
          }
          this.st?.reload(1);
          this.getGoodsSourceStatistical();
        })
    });
  }
  // 批量生成电子单据
  sign1(item?: any) {
    if(this.selectedRows.length <= 0) {
      this.service.msgSrv.error('请选择订单！')
      return
    }
    let params: any[] = [];
    this.selectedRows.forEach(item => {
      params.push(item.id);
    });
    this.modal.confirm({
      nzTitle: `<b>已选择${this.selectedRows.length}条订单，确认批量生成电子单据吗？</b>`,
      nzContent: `<b>确认后单据不可修改，请谨慎操作。</b>`,
      nzOnOk: () =>
        this.service.request(this.service.$api_get_cancelAnOrder, { ids: params }).subscribe(res => {
          if (res === true) {
            this.service.msgSrv.success('操作成功！');
            this.st?.reload(1);
            this.getGoodsSourceStatistical();
            this.initST();
          }
          this.st?.reload(1);
          this.getGoodsSourceStatistical();
        })
    });
  }
}
